#include "CEventCallbacks.h"

STDMETHODIMP CEventCallbacks::QueryInterface(__in REFIID InterfaceId, __out PVOID* Interface)
{
    *Interface = NULL;
    if (IsEqualIID(InterfaceId, __uuidof(IUnknown)) || IsEqualIID(InterfaceId, __uuidof(IDebugOutputCallbacks)))
    {
        *Interface = (IDebugOutputCallbacks *)this;
        InterlockedIncrement(&m_ref);
        return S_OK;
    }
    else
    {
        return E_NOINTERFACE;
    }
}

STDMETHODIMP CEventCallbacks::Exception(__in PEXCEPTION_RECORD64 Exception, __in ULONG FirstChance)
{
	return DEBUG_STATUS_BREAK;
}

STDMETHODIMP_(ULONG) CEventCallbacks::AddRef()
{
    return InterlockedIncrement(&m_ref);
}

STDMETHODIMP_(ULONG) CEventCallbacks::Release()
{
    LONG ref = InterlockedDecrement(&m_ref);
    if (ref == 0)
    {
        delete this;
    }
    return ref;
}

STDMETHODIMP CEventCallbacks::Breakpoint(__in PDEBUG_BREAKPOINT pBp)
{
	ULONG* pId = new ULONG;
	pBp->GetId(pId);
	numHits++;
	delete[] pId;
	return S_OK;
}

STDMETHODIMP CEventCallbacks::GetInterestMask(__out PULONG mask)
{
	*mask = DEBUG_EVENT_BREAKPOINT;
	return S_OK;
}

STDMETHODIMP_(ULONG) CEventCallbacks::GetNumHits()
{
	return numHits;
}

STDMETHODIMP CEventCallbacks::CreateThread(__in ULONG64 handle, __in ULONG64 DataOffset, __in ULONG64 StartOffset)
{
	return DEBUG_STATUS_BREAK;
}