// MyExt.cpp

#include "dbgext.h"

//For kernel debug: -k net:port=50001,key=2im0oy4bkvegh.16s1qfawr7994.2zmn7v9zrl41a.4y018vkj8x0e
//Use test PROCESS: ffffe001b4786840

HRESULT CALLBACK 
driverlocked(IDebugClient* pDebugClient, PCSTR args) 
{
  HRESULT hRes = E_FAIL;
  IDebugControl* pDebugControl;
  if (SUCCEEDED( hRes = pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl))) 
  {
	  //Read LockedPagesList (offset 0x4b0 from _EPROCESS)
	  PVOID *lockAddr = new PVOID;
	  ReadLockedPagesList(pDebugClient,args,lockAddr);
	  pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Lock Header Addr: %p \n", *lockAddr);
	  TraverseTree(pDebugClient, lockAddr);


	  //Release allocations:
	  delete[] lockAddr;
	  pDebugControl->Release();
  }
  return hRes;
}

HRESULT CALLBACK
findlockedpages(IDebugClient* pDebugClient, PCSTR args)
{
	
	HRESULT hRes = E_FAIL;
	IDebugControl* pDebugControl;
	IDebugSystemObjects* pSystemObjects;
	UNREFERENCED_PARAMETER(args);

	if (SUCCEEDED( hRes = pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl))) 
	{
		if(SUCCEEDED (hRes = pDebugClient->QueryInterface(__uuidof(IDebugSystemObjects), (void **)&pSystemObjects)))
		{
			ULONG64* currentProc = new ULONG64;
			if(SUCCEEDED (hRes = pSystemObjects->GetCurrentProcessDataOffset(currentProc)))
			{
				pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Listing all processes that have locked pages... \n \n");
				TraverseLockedPages(pDebugClient);
			}
			else
			{
				pDebugControl->Output(DEBUG_OUTPUT_ERROR, "GetCurrentProcess failed HRESULT:%x \n", hRes);
			}
			pSystemObjects->Release();
		}
		pDebugControl->Release();
	}
	
	return hRes;
}

HRESULT CALLBACK
findfield(IDebugClient* pDebugClient, PCSTR args)
{
	HRESULT hRes = E_FAIL;
	ULONG* fieldBase = new ULONG;
	UNREFERENCED_PARAMETER(args);
	hRes = FindFieldOffset(pDebugClient,"LockedPagesList", "_EPROCESS", "ntdll", fieldBase);

	delete[] fieldBase;
	return hRes;
}

HRESULT CALLBACK
findmdl(IDebugClient* pDebugClient, PCSTR args)
{
	//Find all MDL usage 
	HRESULT hRes = E_FAIL;
	UNREFERENCED_PARAMETER(args);
	hRes = ReadPfnDatabase(pDebugClient);
	return hRes;
}

HRESULT CALLBACK
writemdl(IDebugClient* pDebugClient, PCSTR args)
{
	HRESULT hRes = E_FAIL;
	UNREFERENCED_PARAMETER(args);
	hRes = WriteVM(pDebugClient);
	return hRes;
}

HRESULT CALLBACK
poolheader(IDebugClient* pDebugClient, PCSTR args)
{
	HRESULT hRes = E_FAIL;
	hRes = ReadPoolHeader(pDebugClient, args);
	return hRes;
}

HRESULT CALLBACK
findmdlheaders(IDebugClient *pDebugClient, PCSTR args)
{
	HRESULT hRes = E_FAIL;
	UNREFERENCED_PARAMETER(args);
	hRes = FindValidMdls(pDebugClient);
	return hRes;
}

HRESULT CALLBACK
writemem(IDebugClient *pDebugClient, PCSTR args)
{
	HRESULT hRes = E_FAIL;
	hRes = WriteMem(pDebugClient, 0xffffe0013c200000, 0x80000, args);
	//hRes = WriteMem(pDebugClient, 0xffffe0013c600000, 0x80000, args);	
	return hRes;
}