#include "MDL.h"

MDL::MDL()
{
	mdlAddr = new ULONG64;
	procAddr = new ULONG64;
	byteCount = 0;
	byteOffset = 0;
	valid = false;
	isLinked = false;
}

MDL::MDL(IDebugClient *pDebugClient, ULONG64 adr)
{
	mdlAddr = new ULONG64;
	*mdlAddr = (ULONG64) adr;
	procAddr = new ULONG64;
	byteCount = 0;
	byteOffset = 0;
	valid = ReadProcess(pDebugClient);
	valid = ReadBytes(pDebugClient);
	isLinked = checkNext(pDebugClient);
}

MDL::~MDL()
{
	delete[] mdlAddr;
	delete[] procAddr;
}

VOID MDL::updateAddr(IDebugClient *pDebugClient, ULONG64 adr)
{
	*mdlAddr = adr;
	valid = ReadProcess(pDebugClient);
	isLinked = checkNext(pDebugClient);
}

BOOL MDL::checkNext(IDebugClient *pDebugClient)
{
	PVOID *buf = new PVOID;
	BOOL linked = false;
	if( SUCCEEDED (ReadVirtual(pDebugClient, *mdlAddr, buf, 8, NULL)))
	{
		if( (ULONG64) *buf != NULL)
		{
			linked = true;
		}
	}
	return linked;
}

BOOL MDL::ReadProcess(IDebugClient *pDebugClient)
{
	BOOL success = false;
	ULONG *offset = new ULONG;
	HRESULT hRes = FindFieldOffset(pDebugClient, "Process", "_MDL", "ntdll", offset);
	
	if(hRes == S_OK)
	{
		ULONG64 addrOffset = *mdlAddr + (ULONG64) *offset;
		PVOID *buf = new PVOID;
		if( SUCCEEDED (ReadVirtual(pDebugClient, addrOffset, buf, 8, NULL)))
		{
			success = true;
			*procAddr = (ULONG64) *buf;
		}
		delete[] buf;
	}
	delete[] offset;

	return success;
}

BOOL MDL::ReadBytes(IDebugClient *pDebugClient)
{
	BOOL success = false;
	ULONG *offset = new ULONG;
	HRESULT hRes = FindFieldOffset(pDebugClient, "ByteCount", "_MDL", "ntdll", offset);

	if(hRes == S_OK)
	{
		ULONG64 addrOffset = *mdlAddr + (ULONG64) *offset;
		PVOID *buf = new PVOID;
		if( SUCCEEDED (ReadVirtual(pDebugClient, addrOffset, buf, 4, NULL)))
		{
			success = true;
			byteCount = (UINT) *buf;
		}
		delete[] buf;
	}

	if(success)
	{
		hRes = FindFieldOffset(pDebugClient, "ByteOffset", "_MDL", "ntdll", offset);

		if(hRes == S_OK)
		{
			ULONG64 addrOffset = *mdlAddr + (ULONG64) *offset;
			PVOID *buf = new PVOID;
			if( SUCCEEDED (ReadVirtual(pDebugClient, addrOffset, buf, 4, NULL)))
			{
				success = true;
				byteOffset = (UINT) *buf;
			}
			delete[] buf;
		}
		else
		{
			success = false;
		}
		
	}
	delete[] offset;
	return success;
}