#include "ModuleFunctions.h"

HRESULT FindModuleBase(IDebugClient* pDebugClient, PCSTR moduleName, PULONG64 baseAdr)
{
	HRESULT hRes = E_FAIL;
	IDebugControl* pDebugControl;
	IDebugSymbols *pSymbols;
	if (SUCCEEDED( hRes = pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		if(SUCCEEDED ( hRes = pDebugClient->QueryInterface(__uuidof(IDebugSymbols), (void **) &pSymbols)))
		{
			//fIND ULONG64 of module ntdll
			if( SUCCEEDED (hRes = pSymbols->GetModuleByModuleName(moduleName,0,NULL, baseAdr)))
			{
				//pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "%s base address: %p \n", moduleName, *baseAdr);
			}
			else
			{
				pDebugControl->Output(DEBUG_OUTPUT_ERROR, "Failed to retrieve %s base. HRESULT %u \n", moduleName, hRes);
				baseAdr = 0;
			}
			pSymbols->Release();
			
		}
		pDebugControl->Release();
	}
	return hRes;
}

HRESULT FindFieldOffset(IDebugClient* pDebugClient, PCSTR fieldname, PCSTR objname, PCSTR modulename, PULONG fieldBase)
{
	HRESULT hRes = E_FAIL;
	IDebugControl* pDebugControl;
	IDebugSymbols *pSymbols;
	ULONG64* modBase = new ULONG64;
	ULONG* typeId = new ULONG;

	if (SUCCEEDED( hRes = pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		if(SUCCEEDED ( hRes = pDebugClient->QueryInterface(__uuidof(IDebugSymbols), (void **) &pSymbols)))
		{
			
			if(SUCCEEDED (hRes = FindModuleBase(pDebugClient, modulename, modBase)))
			{
				if( SUCCEEDED (hRes = pSymbols->GetTypeId(*modBase, objname, typeId)))
				{
					//pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "%s ID: %p \n", objname, *typeId);

					if( SUCCEEDED (hRes = pSymbols->GetFieldOffset(*modBase, *typeId, fieldname, fieldBase)))
					{
						//pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "%s offset: %p \n", fieldname, *fieldBase);
					}
					else
					{
						pDebugControl->Output(DEBUG_OUTPUT_ERROR, "Failed to retrieve %s. HRESULT %u \n", fieldname, hRes);
					}
					
				}
				else
				{
					pDebugControl->Output(DEBUG_OUTPUT_ERROR, "Failed to retrieve type ID for type %s. HRESULT %u \n", objname, hRes);
				}
			}
			pSymbols->Release();			
		}
		pDebugControl->Release();
	}
	delete[] modBase;
	delete[] typeId;
	
	return hRes;
}
