//Node.cpp

#include "NODE.h"
#include "MemoryFunctions.h"


NODE::NODE(ULONG64 rootAdr, IDebugClient *pDebugClient)
{
	nodeAdr = new PVOID;
	leftAdr = new PVOID;
	rightAdr = new PVOID;
	lengthAdr  = new PVOID;
	
	//Read main node:
	ReadVirtual(pDebugClient, rootAdr, nodeAdr,  8, NULL); 
	//Read children:
	ReadVirtualC(pDebugClient, (ULONG64) *nodeAdr, leftAdr, rightAdr,  8, NULL);
	//Read length:
	ReadVirtual(pDebugClient, ((ULONG64) *nodeAdr + 0x34), lengthAdr,  4, NULL);
}

NODE::~NODE()
{
	delete[] nodeAdr;
	delete[] leftAdr;
	delete[] rightAdr;
	delete[] lengthAdr;
}

void NODE::setadr(ULONG64 adr, IDebugClient *pDebugClient)
{
	//Read main node:
	*nodeAdr = (PVOID) adr; 
	//Read children:
	ReadVirtualC(pDebugClient, adr, leftAdr, rightAdr,  8, NULL); 
	//Read length:
	ReadVirtual(pDebugClient, adr+0x34, lengthAdr, 4, NULL);
}

ULONG64 NODE::adr()
{
	return (ULONG64) *nodeAdr;
}

ULONG64 NODE::left()
{
	return (ULONG64) *leftAdr;
}

ULONG64 NODE::right()
{
	return (ULONG64) *rightAdr;
}

UINT NODE::length()
{
	return (UINT) *lengthAdr;
}

