#include "PFNdata.h"

PFNdata::PFNdata(IDebugClient *pDebugClient, ULONG pfnNo)
{
	pfnAdr = new ULONG64;
	*pfnAdr = pfnToAddr(pfnNo);
	pteAdr = new ULONG64;
	valid = readPte(pDebugClient);
	/*PULONG64 adr = new ULONG64;
	*adr = readProcess(pDebugClient);
	if( *adr != 0)
	{
		ownProc = new PROCESS(pDebugClient, adr);
	}
	else
	{
		ownProc = new PROCESS();
	}
	delete[] adr;*/
	procAdr = new ULONG64;
	*procAdr = readProcess(pDebugClient);

}

PFNdata::~PFNdata()
{
	delete[] pfnAdr;
	delete[] pteAdr;
	delete[] procAdr;
}

ULONG64 PFNdata::pfnToAddr(ULONG pfnNO)
{
	//PFNbase addr:
	ULONG64 addr = 0xfffffa8000000000;
	ULONG64 pfnSize = 0x30;
	ULONG64 offset = 0x30 * pfnNO;
	addr += offset;
	return addr;
}

BOOL PFNdata::readPte(IDebugClient *pDebugClient)
{
	BOOL success = false;
	ULONG64 offset = *pfnAdr + 0x8;
	PVOID *buf = new PVOID; 
	HRESULT hRes = ReadVirtual(pDebugClient, offset, buf, 8, NULL);

	if(hRes == S_OK)
	{
		success = true;
		*pteAdr = (ULONG64) *buf;
	}
	else
	{
		*pteAdr = 0;
	}

	delete[] buf;
	return success;

}

BOOL PFNdata::isDriverLocked()
{
	BOOL isLocked = false;
	if(*pteAdr == 0xfffff68000000000)
	{
		isLocked = true;
	}
	return isLocked;
}

ULONG64 PFNdata::readProcess(IDebugClient *pDebugClient)
{
	ULONG64 adr = 0;
	if(isDriverLocked())
	{
		PVOID *buf = new PVOID;
		if(SUCCEEDED(ReadVirtual(pDebugClient, *pfnAdr, buf, 8, NULL)))
		{
			adr = (ULONG64) *buf;
		}
	}
	return adr;

}


