#ifndef POOL_H
#define POOL_H

#include <DbgEng.h>
#include "MemoryFunctions.h"

class POOL

{

public:
	POOL(IDebugClient *pDebugClient, ULONG64 adr);
	~POOL();
	UINT getPrevSize(){return prevSize;}
	UINT getPoolIndex(){return poolIndex;}
	UINT getBlockSize(){return blockSize;}
	ULONG64 getAdr() {return *poolAdr;}
	UINT getTag(){return tag;}
	BOOL getValid(){return valid;}
	
	VOID outputData(IDebugClient *pDebugClient);
private:
	//Ulong: (4 byte) (0x0)
	UINT prevSize;
	UINT poolIndex;
	UINT blockSize;
	UINT poolType;
	//Tag: (4 byte) (0x4)
	UINT tag;
	char *szTag; 
	//Process: (8 byte) (0x8)
	ULONG64 process;
	PULONG64 poolAdr;
	BOOL valid;
	BOOL isValid();
	BOOL readData(IDebugClient *pDebugClient);
};

#endif;