#include "POOL.h"



POOL::POOL(IDebugClient *pDebugClient, ULONG64 adr)
{
	poolAdr = new ULONG64;
	szTag  = new char[5];
	*poolAdr = adr;
	valid = readData(pDebugClient);
	isValid();
}

POOL::~POOL()
{
	delete[] poolAdr;
	delete[] szTag;
}

BOOL POOL::readData(IDebugClient *pDebugClient)
{
	BOOL success = false;

	//Read Ulong offset = 0x0;
	PVOID *buf = new PVOID;
	if (SUCCEEDED (ReadVirtual(pDebugClient, *poolAdr, buf, 4, NULL)))
	{
		UINT PREVMASK   = 0xFF;
		UINT INDMASK    = 0xFF00;
		UINT BLOCKMASK  = 0xFF0000;
		UINT TYPEMASK   = 0xFF000000;

		UINT info = (UINT) *buf;
		prevSize  = info & PREVMASK;
		poolIndex = (info & INDMASK) >> 8;
		blockSize = (info & BLOCKMASK) >> 16;
		poolType  = (info & TYPEMASK) >> 24;

		if (SUCCEEDED (ReadVirtual(pDebugClient, *poolAdr+0x4, buf, 4, NULL)))
		{
			tag = (UINT) *buf;
			//szTag = (char*) *buf.c_str();
			//szTag[5] = 0;
			
			if (SUCCEEDED (ReadVirtual(pDebugClient, *poolAdr+0x8, buf, 8, NULL)))
			{
				process = (ULONG64) *buf;
				success = true;
			}
		}
	}

	
	delete[] buf;


	return success;
}

VOID POOL::outputData(IDebugClient *pDebugClient)
{
	IDebugControl *pDebugControl;
	HRESULT hr = E_FAIL;
	if (SUCCEEDED( hr = pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl))) 
	{
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Previous size: 0x%u0 \n", prevSize);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Pool Index: %u \n", poolIndex);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Block size: 0x%u0 \n", blockSize);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Pool type: %u \n", poolType);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Tag: %u \n", tag);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Process: %p \n", process);
		pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Valid %u \n", valid);
		//pDebugControl->Output(DEBUG_OUTPUT_NORMAL, "Tag - string : %s \n", szTag);
		pDebugControl->Release();
	}
}

BOOL POOL::isValid()
{
	valid = false;
	if( poolType == 2 && blockSize > 0)
	{
		valid = true;
	}
	return valid;
}


