//ProcessFunctions.h
/*All functions working on _EPROCESS object*/
/*By Hans Kristian Brendmo*/
#include <DbgEng.h>
#include "MemoryFunctions.h"
#include "SupportFunctions.h"
#include "process.h"


//Used to trace driverlocked memory:
HRESULT ReadLockedPagesList(IDebugClient* pDebugClient, PCSTR args, PVOID output);
HRESULT ReadLockedPagesList(IDebugClient* pDebugClient, ULONG64 arg, PVOID output);

//Traverse all active processes - finding locked pages
HRESULT TraverseLockedPages(IDebugClient* pDebugClient);

//General process functions:
HRESULT GetCurrentProcess(IDebugClient* pDebugClient, PVOID process);
HRESULT GetNextProcess(IDebugClient* pDebugClient, PULONG64 process, PULONG64 nextprocess);

//Find process name (max 15 chars)
HRESULT ReadProcessName(IDebugClient* pDebugClient, ULONG64 eProcess, PVOID name);