//Process.h - For handling process objects:
//By Hans Kristian Brendmo


#ifndef PROCESS_H
#define PROCESS_H

#include <DbgEng.h>
#include "SupportFunctions.h"
#include "MemoryFunctions.h"

class PROCESS
{
public:
	PROCESS();
	PROCESS(IDebugClient *pDebugClient, PULONG64 addr);
	~PROCESS();

	BOOL isValid() {return valid;}
	ULONG64 getEprocess() {return *eProcess;}
	PCSTR getName() {return name;}
	ULONG64 getNextProcess(IDebugClient *pDebugClient);
	ULONG getCount() {return *lockedPagesCount;}
	BOOL hasLockedPages();
	VOID update(IDebugClient *pDebugClient, PULONG64 addr);

private:
	BOOL readProcessList(IDebugClient *pDebugClient);
	BOOL readLockedPagesList(IDebugClient *pDebugClient);
	BOOL readLockedPagesCount(IDebugClient *pDebugClient);
	BOOL readProcessName(IDebugClient *pDebugClient);
	BOOL isProcessValid(IDebugClient *pDebugClient); 
	PULONG64 eProcess;
	PCSTR name;
	PULONG activeProcessList;
	PULONG64 lockedPagesList;
	PULONG lockedPagesCount;
	BOOL valid;

};

#endif;