#include "DLIST.h"
#include "MemoryFunc.h"

DLIST::DLIST() : fLink(0), bLink(0)
{
}
DLIST::DLIST(ULONG64 fL, ULONG64 bL) : fLink(fL), bLink(bL)
{
}

DLIST::DLIST(ULONG64 *arr)
{
	fLink = arr[0];
	bLink = arr[1];
}

VOID DLIST::Update(ULONG64 *arr)
{
	fLink = arr[0];
	bLink = arr[1];
}

VOID DLIST::Update(ULONG64 fL, ULONG64 bL)
{
	fLink = fL;
	bLink = bL;
}

DLIST::~DLIST()
{
}

UINT DLIST::size(ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2)
{
	ULONG64 start = fLink;
	ULONG64 backLink = 0;
	UINT size = 1;
	const UINT MAXSIZE = 100;
	DLIST *nextEntry = new DLIST(fLink, bLink);
	for(UINT i = 0; i < (MAXSIZE) && nextEntry->back() != start; i++)
	{
		//Nextlink:
		ULONG64 nextAdrp = TranslateAddress(nextEntry->back(), pageDir, hFile1, hFile2);
		HANDLE hOpen = ChooseFile(&hFile1, &hFile2, &nextAdrp);
		ULONG64 nextBuf[2];
		if(ReadPhysical(nextAdrp, nextBuf, 16, hOpen))
		{
			nextEntry->Update(nextBuf);
		}
		else
		{
			_tprintf(_T("Error\n"));
			size = -1;
			break;
		}
		
		size++;
	}
	delete nextEntry;
	return size;
}

BOOL DLIST::Traverse(ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2, UINT numElements, ULONG64 *addressesv)
{
	ULONG64 start = fLink;
	ULONG64 backLink = 0;
	BOOL success = false;
	const UINT MAXSIZE = 100;
	DLIST *nextEntry = new DLIST(fLink, bLink);
	for(UINT i = 0; i < (MAXSIZE) && i < (numElements); i++)
	{
		ULONG64 nextAdrp = TranslateAddress(nextEntry->back(), pageDir, hFile1, hFile2);
		HANDLE hOpen = ChooseFile(&hFile1, &hFile2, &nextAdrp);
		ULONG64 nextBuf[2];
		if(ReadPhysical(nextAdrp, nextBuf, 16, hOpen))
		{
			nextEntry->Update(nextBuf);
			addressesv[i] = nextEntry->back();
			success = true;
		}
		else
		{
			_tprintf(_T("Error\n"));
			success = false;
			break;

		}
		
	}
	return success;
}