/**********************************************************
Functions used for operations on physical and virtual memory
By Hans Kristian Brendmo
**********************************************************/
#include "Helper.h"

//Virtual address translation:
ULONG64 TranslateAddress(ULONG64 virtAddress, ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2);
ULONG64 TranslatePXE(ULONG64 virtAddress, ULONG64 pagedir);
ULONG64 TranslatePPE(ULONG64 virtAddress, ULONG64 physAdr);
ULONG64 TranslatePDE(ULONG64 virtAddress, ULONG64 physAdr);
ULONG64 TranslatePTE(ULONG64 virtAddress, ULONG64 physAdr);
ULONG64 TranslateLargePage(ULONG64 virtAddress, ULONG64 physAdr);


BOOL ReadPhysical(ULONG64 physAddress, PVOID buf, UINT bytes, HANDLE hFil);
BOOL ReadVirtual(ULONG64 virtAddress, ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2, PVOID buf, UINT bytes);

HANDLE ChooseFile(HANDLE *hFile1, HANDLE *hFile2, ULONG64 *physAdr);