#include "SecureKernelFunc.h"
#include "MemoryFunc.h"
#include "SupportFunc.h"
#include "MiscFunc.h"
#include "DLIST.h"


BOOL skDumpVariables(HANDLE hOpen, ULONG64 baseAdrp)
{
	BOOL success = false;
	const UINT POINTSIZE = 8;
	ULONG64 IumSecureKernelStartOFF = 0x49d20;
	ULONG64 ShvlpPageDirectoryBaseOFF = 0x59118;
	ULONG64 PsIumSystemProcessOFF = 0x58418;
	ULONG64 SkiProcessListOFF = 0x5a3f0;
	ULONG64 SkmiLowestPhysicalPageOFF = 0x64010;
	ULONG64 SkmiHighestPhysicalPageOFF = 0x64018;
	ULONG64 IumCrashCpuContextOFF = 0x64510;
	ULONG64 SkImageBaseOFF = 0x58c18;
	ULONG64 SkLoadedModuleListOFF = 0x517e0;
	ULONG64 SkiThreadTableOFF = 0x5a388;
	

	//ium secure kern start:
	PVOID *buf1 = new PVOID;
	ReadPhysical(baseAdrp + IumSecureKernelStartOFF, buf1, POINTSIZE, hOpen);

	//ium ShvlPageDirectoryBaseOFF
	PVOID *buf2 = new PVOID;
	ReadPhysical(baseAdrp + ShvlpPageDirectoryBaseOFF, buf2, POINTSIZE, hOpen);

	//PsIumSystemProcessOFF
	PVOID *buf3 = new PVOID;
	ReadPhysical(baseAdrp + PsIumSystemProcessOFF, buf3, POINTSIZE, hOpen);

	//SkmiLowestPhysicalPageOFF
	PVOID *buf4 = new PVOID;
	ReadPhysical(baseAdrp + SkmiLowestPhysicalPageOFF, buf4, POINTSIZE, hOpen);

	//SkmiHighestPhysicalPage
	PVOID *buf5 = new PVOID;
	ReadPhysical(baseAdrp + SkmiHighestPhysicalPageOFF, buf5, POINTSIZE, hOpen);

	//SkiProcessList
	PVOID *buf6 = new PVOID;
	ReadPhysical(baseAdrp + SkiProcessListOFF, buf6, POINTSIZE, hOpen);

	//SkiImageBase
	PVOID *buf7 = new PVOID;
	ReadPhysical(baseAdrp + SkImageBaseOFF, buf7, POINTSIZE, hOpen);

	//SkLoadedModuleList
	PVOID *buf8 = new PVOID;
	ReadPhysical(baseAdrp + SkLoadedModuleListOFF, buf8, POINTSIZE, hOpen);

	//SkiThreadTable
	PVOID *buf9 = new PVOID;
	ReadPhysical(baseAdrp + SkiThreadTableOFF, buf9, POINTSIZE, hOpen);

	//SkLoaded
	//Output:
	_tprintf(_T("IumSecureKernelStart: 0x%p \n"), (ULONG64) *buf1);
	_tprintf(_T("ShvlPageDirectoryBase: 0x%p \n"), (ULONG64) *buf2);
	_tprintf(_T("PsIumSystemProcess: 0x%p \n"), (ULONG64) *buf3);
	_tprintf(_T("SkmiLowestPhysicalPage: 0x%p \n"), (ULONG64) *buf4);
	_tprintf(_T("SkmiHighestPhysicalPage: 0x%p \n"), (ULONG64) *buf5);
	_tprintf(_T("SkiProcessList: 0x%p \n"), (ULONG64) *buf6);
	_tprintf(_T("SkImageBase: 0x%p \n"), (ULONG64) *buf7);
	_tprintf(_T("SkLoadedModuleList: 0x%p \n"), (ULONG64) *buf8);
	_tprintf(_T("SkiThreadTable: 0x%p \n"), (ULONG64) *buf9);

	delete[] buf1;
	delete[] buf2;
	delete[] buf3;
	delete[] buf4;
	delete[] buf5;
	delete[] buf6;
	delete[] buf7;
	delete[] buf8;
	delete[] buf9;

	return success;

}

BOOL skDumpVar(HANDLE hFile1, ULONG64 baseAdrp, ULONG64 offset)
{
	PVOID *buf = new PVOID;
	BOOL success = false;
	BOOL bufOffset = 0;
	UINT POINTSIZE = 8;
	for(UINT i = 0; i < 16; i++)
	{
		success = ReadPhysical(baseAdrp + offset + bufOffset, buf, POINTSIZE, hFile1);
		bufOffset += POINTSIZE;
		_tprintf(_T("%p "), (ULONG64) *buf);
		success = ReadPhysical(baseAdrp + offset + bufOffset, buf, POINTSIZE, hFile1);
		_tprintf(_T("%p \n"), (ULONG64) *buf);
		bufOffset += POINTSIZE;
	}

	delete[] buf;
	return success;
}

BOOL SearchForSKOB(HANDLE hFile1, HANDLE hFile2, ULONG64 baseAdrv)
{
	//Pat length:
	UINT matches1 = 0;
	UINT matches2 = 0;
	const UINT PATLENGTH = 4;
	//Offsets for differnent SKOB objects:
	ULONG64 processTypeOffset = 0x49bc8;
	ULONG64 imageTypeOffset   = 0x49be8;
	ULONG64 eventTypeOffset   = 0x4a5f8;
	ULONG64 threadTypeOffset  = 0x49dd8;
	ULONG64 securAllocOffset  = 0x49bd8;
	ULONG64 workFacTypeOffset = 0x49c60;
	//SearchPattern:
	BYTE processPat [PATLENGTH];
	DWORD tag = 0x424f4b53; //SKOB
	DwordToByteArr(processPat, tag, 0);

	//Find all SKOB objects:
	const UINT MAXFIND = 200;
	ULONG64 offsets1[MAXFIND];
	ULONG64 offsets2[MAXFIND];
	_tprintf(_T("Searching file 1...\n"));
	matches1 = SearchFile(hFile1, processPat, PATLENGTH, 2047, offsets1, MAXFIND);
	_tprintf(_T("Search complete %u matches found.\n"), matches1);

	_tprintf(_T("Searching file 2...\n"));
	matches2 = SearchFile(hFile2, processPat, PATLENGTH, 2047, offsets2, MAXFIND);
	_tprintf(_T("Search complete %u matches found.\n"), matches2);
	UINT numProcess = 0;
	UINT numImages = 0;
	UINT numEvents = 0;
	UINT numThreads = 0;
	UINT numsecurAlloc = 0;
	UINT numWorkFacs = 0;
	UINT numUnknowns = 0;
	ULONG64 threadOffsets[MAXFIND];
	ULONG64 imageOffsets[MAXFIND];
	UINT imagesFile1 = 0;

	//Process objects:
	
	for(UINT i = 0; i < matches1; i++)
	{
		PVOID *type = new PVOID;
		ReadPhysical(offsets1[i] + 9, type, 8, hFile1);
		if((ULONG64) *type == (baseAdrv + processTypeOffset))
		{
			++numProcess;
		}
		else if((ULONG64) *type == (baseAdrv + imageTypeOffset))
		{
			//_tprintf(_T("Image object found at offset: %p \n"),offsets1[i]);
			imageOffsets[numImages] = offsets1[i];
			++numImages;
		}
		else if((ULONG64) *type == (baseAdrv + eventTypeOffset))
		{
			++numEvents;
		}
		else if((ULONG64) *type == (baseAdrv +  threadTypeOffset))
		{
			threadOffsets[numThreads] = offsets1[i];
			++numThreads;
		}
		else if((ULONG64) *type == (baseAdrv +  securAllocOffset))
		{
			++numsecurAlloc;
		}
		else if((ULONG64) *type == (baseAdrv +  workFacTypeOffset))
		{
			++numWorkFacs;
		}
		else
		{
			_tprintf(_T("Unknown type for file 1 at %p , type %p\n"), offsets1[i], *type);
			++numUnknowns;
		}
		delete[] type;
	}
	imagesFile1 = numImages;
	_tprintf(_T("\n\n"));

	for(UINT i = 0; i < matches2; i++)
	{
		PVOID *type = new PVOID;
		ReadPhysical(offsets2[i] + 9, type, 8, hFile2);
		if((ULONG64) *type == (baseAdrv + processTypeOffset))
		{
			++numProcess;
		}
		else if((ULONG64) *type == (baseAdrv + imageTypeOffset))
		{
			++numImages;
		}
		else if((ULONG64) *type == (baseAdrv + eventTypeOffset))
		{
			++numEvents;
		}
		else if((ULONG64) *type == (baseAdrv +  threadTypeOffset))
		{
			threadOffsets[numThreads] = offsets2[i];
			++numThreads;
		}
		else if((ULONG64) *type == (baseAdrv +  securAllocOffset))
		{
			++numsecurAlloc;
		}
		else if((ULONG64) *type == (baseAdrv +  workFacTypeOffset))
		{
			++numWorkFacs;
		}
		else
		{
			_tprintf(_T("Unknown type for file 2 at %p , type %p\n"), offsets2[i], *type);
			++numUnknowns;
		}
		delete[] type;
	}
	_tprintf(_T("\nStatistics: \n"));
	_tprintf(_T("Number of processes: %u \n"), numProcess);
	_tprintf(_T("Number of images: %u \n"), numImages);
	_tprintf(_T("Number of events: %u \n"), numEvents);
	_tprintf(_T("Number of threads: %u \n"), numThreads);
	_tprintf(_T("Number of Secure Allocations: %u \n"), numsecurAlloc);
	_tprintf(_T("Number of Worker Factories: %u \n"), numWorkFacs);
	_tprintf(_T("Number of Unknowns: %u \n"), numUnknowns);
	_tprintf(_T("\nMatches for file 1: %u, matches for file 2: %u.\n"),matches1,matches2);
	
	for(UINT i = 0; i < numThreads; i++)
	{
		_tprintf(_T("\nThread physical offset:%p\n"),threadOffsets[i]);
	}
	_tprintf(_T("Images for file 1:"));
	for(UINT i = 0; i < imagesFile1; i++)
	{
		_tprintf(_T("\nImage physical offset:%p\n"), (imageOffsets[i] + 1) + 0x100000000);
	}
	return (matches1 + matches2);

}

BOOL skLoadedModules(ULONG64 lmAdrv, ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2)
{
	ULONG64 listBuf[2];
	ReadVirtual(lmAdrv, pageDir, hFile1, hFile2, listBuf, 16);

	DLIST *loadedModuleList = new DLIST(listBuf);
	UINT numberOfModules = loadedModuleList->size(pageDir, hFile1, hFile2);
	_tprintf(_T("\n--------------Loaded modules------------------\n"));
	_tprintf(_T("Starting Address:  Ending Address:    Name: \n"));
	if(numberOfModules > 0)
	{
		//PrintList:
		ULONG64 *allModules = new ULONG64[numberOfModules];
		if(loadedModuleList->Traverse(pageDir, hFile1, hFile2, numberOfModules, allModules))
		{
			ULONG64 baseAdrOffset = 0x30;
			ULONG64 imageSizeOffset = 0x40;
			ULONG64 baseNameOffset = 0x58;
			for(UINT i = 0; i < numberOfModules; i++)
			{
				//Read base address:
				ULONG64 *baseAddress = new ULONG64;	
				if(ReadVirtual(allModules[i] + baseAdrOffset, pageDir, hFile1, hFile2, baseAddress, 8))
				{
					_tprintf(_T("%p"),*baseAddress);
				}
				else
				{
					_tprintf(_T("Error when reading base address: \n"));
					break;
				}

				//Read size:
				ULONG64 *moduleSize = new ULONG64;
				if(ReadVirtual(allModules[i] + imageSizeOffset, pageDir, hFile1, hFile2, moduleSize, 8))
				{
					_tprintf(_T("   %p   "), (*baseAddress + *moduleSize) );
				}
				else
				{
					_tprintf(_T("Error when reading moduleSize  \n"));
					break;
				}

		
				//Read name:
				ULONG64 stringData[2];
				if(ReadVirtual(allModules[i] + baseNameOffset, pageDir, hFile1, hFile2, stringData, 16))
				{
					ULONG64 stringVirtAdr = stringData[1];
					ULONG64 stringPhysAdr = TranslateAddress(stringVirtAdr, pageDir, hFile1, hFile2);
					HANDLE hOpen = ChooseFile(&hFile1, &hFile2, &stringPhysAdr);
					//_tprintf(_T("Stringdata: %p, stringadr: %p \n"),stringData[0], stringData[1]);
					if(PrintUnicodeString(stringPhysAdr, stringData[0], hOpen))
					{						
					}
					else
					{
						_tprintf(_T("Error when printing module name at physical address: %p \n"), stringPhysAdr);
						break;
					}
				}
				else
				{
					_tprintf(_T("Error when reading stringdata:  \n"));
					break;
				}

			}
		}
	}

	//delete loadedModuleList;
	//delete [] allModules;
	return true;
}

/*0:000> x /d /a securekernel!*
00000001`40048000 securekernel!NlsLeadByteInfoTable = <no type information>
00000001`40048200 securekernel!NlsOemLeadByteInfoTable = <no type information>
00000001`40049000 securekernel!_imp_BCryptImportKeyPair = <no type information>
00000001`40049008 securekernel!_imp_BCryptCreateHash = <no type information>
00000001`40049010 securekernel!_imp_EntropyProvideData = <no type information>
00000001`40049018 securekernel!_imp_BCryptHashData = <no type information>
00000001`40049020 securekernel!_imp_BCryptFinishHash = <no type information>
00000001`40049028 securekernel!_imp_BCryptKeyDerivation = <no type information>
00000001`40049030 securekernel!_imp_BCryptGetProperty = <no type information>
00000001`40049038 securekernel!_imp_BCryptSetProperty = <no type information>
00000001`40049040 securekernel!_imp_CngGetFipsAlgorithmMode = <no type information>
00000001`40049048 securekernel!_imp_BCryptGenRandom = <no type information>
00000001`40049050 securekernel!_imp_EntropyRegisterSource = <no type information>
00000001`40049058 securekernel!_imp_EntropyPoolTriggerReseedForIum = <no type information>
00000001`40049060 securekernel!_imp_BCryptOpenAlgorithmProvider = <no type information>
00000001`40049068 securekernel!_imp_BCryptCloseAlgorithmProvider = <no type information>
00000001`40049070 securekernel!_imp_BCryptDestroyHash = <no type information>
00000001`40049078 securekernel!_imp_BCryptDestroyKey = <no type information>
00000001`40049080 securekernel!_imp_BCryptEncrypt = <no type information>
00000001`40049088 securekernel!_imp_BCryptGenerateSymmetricKey = <no type information>
00000001`40049090 securekernel!_imp_BCryptDecrypt = <no type information>
00000001`40049098 securekernel!_imp_SystemPrng = <no type information>
00000001`400490a0 securekernel!cng_NULL_THUNK_DATA = <no type information>
00000001`400490a8 securekernel!_imp_SkciTransferVersionResource = <no type information>
00000001`400490b0 securekernel!_imp_SkciFinishImageValidation = <no type information>
00000001`400490b8 securekernel!_imp_SkciFinalizeSecureImageHash = <no type information>
00000001`400490c0 securekernel!_imp_SkciValidateDynamicCodePages = <no type information>
00000001`400490c8 securekernel!_imp_SkciValidateImageData = <no type information>
00000001`400490d0 securekernel!_imp_SkciFreeImageContext = <no type information>
00000001`400490d8 securekernel!_imp_SkciCreateSecureImage = <no type information>
00000001`400490e0 securekernel!_imp_SkciInitialize = <no type information>
00000001`400490e8 securekernel!_imp_SkciCreateCodeCatalog = <no type information>
00000001`400490f0 securekernel!skci_NULL_THUNK_DATA = <no type information>
00000001`400490f8 securekernel!_guard_check_icall_fptr = <no type information>
00000001`40049100 securekernel!_guard_dispatch_icall_fptr = <no type information>
00000001`40049108 securekernel!_guard_fids_table = <no type information>
00000001`40049530 securekernel!_newctype = <no type information>
00000001`40049830 securekernel!_newclmap = <no type information>
00000001`400499b0 securekernel!_newcumap = <no type information>
00000001`40049b30 securekernel!_clocalestr = <no type information>
00000001`40049b38 securekernel!_initiallocalestructinfo = <no type information>
00000001`40049b60 securekernel!_lookuptable = <no type information>
00000001`40049bbc securekernel!_lconv_static_decimal = <no type information>
00000001`40049bbe securekernel!_lconv_static_null = <no type information>
00000001`40049bc0 securekernel!_lconv_static_W_decimal = <no type information>
00000001`40049bc4 securekernel!_lconv_static_W_null = <no type information>
00000001`40049bc8 securekernel!SkeProcessType = <no type information>
00000001`40049bd8 securekernel!SkmiSecureAllocationType = <no type information>
00000001`40049be8 securekernel!SkmiImageType = <no type information>
00000001`40049bf8 securekernel!IumSyscallCustomApiFcnTable = <no type information>
00000001`40049c10 securekernel!IumSyscallArgFcnTable = <no type information>
00000001`40049c60 securekernel!SkeWorkerFactoryObjectType = <no type information>
00000001`40049ce0 securekernel!SLEEPSTUDY_ETW_PROVIDER = <no type information>
00000001`40049cf0 securekernel!IumBugCheckVariables = <no type information>
00000001`40049d08 securekernel!SLEEPSTUDY_EVT_SCENARIO_BLOCKER = <no type information>
00000001`40049d18 securekernel!TrustletType_MailboxKey = <no type information>
00000001`40049d20 securekernel!IumSecureKernelStart = <no type information>
00000001`40049d30 securekernel!IumProcessStop = <no type information>
00000001`40049d40 securekernel!Microsoft_Windows_SleepStudyLevels = <no type information>
00000001`40049d44 securekernel!TrustletType_CollaborationId = <no type information>
00000001`40049d48 securekernel!IUM_ETW_PROVIDER = <no type information>
00000001`40049d58 securekernel!IumProcessStartFailed = <no type information>
00000001`40049d68 securekernel!Microsoft_Windows_IsolatedUserModeLevels = <no type information>
00000001`40049d70 securekernel!Microsoft_Windows_IsolatedUserModeKeywords = <no type information>
00000001`40049d80 securekernel!BUGCHECK_EFI_GUID = <no type information>
00000001`40049d90 securekernel!Microsoft_Windows_SleepStudyKeywords = <no type information>
00000001`40049da0 securekernel!IumProcessStart = <no type information>
00000001`40049db0 securekernel!SkiInitialMxCsr = <no type information>
00000001`40049db8 securekernel!GUID_SLEEPSTUDY_BLOCKER_PARENT_IUM = <no type information>
00000001`40049dc8 securekernel!GUID_SLEEPSTUDY_BLOCKER_NO_PARENT = <no type information>
00000001`40049dd8 securekernel!SkeThreadType = <no type information>
00000001`40049de8 securekernel!`EnableManifestedProviderForMicrosoftTelemetry'::`2'::Traits = <no type information>
00000001`40049e00 securekernel!SkpEncryptionKeyHv = <no type information>
00000001`4004a020 securekernel!SkpEncryptionKeyGuidHv = <no type information>
00000001`4004a030 securekernel!SkpEncryptionKeySk = <no type information>
00000001`4004a250 securekernel!SkpEncryptionKeyGuidSk = <no type information>
00000001`4004a280 securekernel!ShvlpHypercallEntry = <no type information>
00000001`4004a2a0 securekernel!SkmiProtectToValue = <no type information>
00000001`4004a2e0 securekernel!SkmiUserProtectionToMask2 = <no type information>
00000001`4004a2f0 securekernel!SkmiUserProtectionToMask1 = <no type information>
00000001`4004a400 securekernel!NtdllExports = <no type information>
00000001`4004a4a0 securekernel!RtlpBitsClearLow = <no type information>
00000001`4004a5a0 securekernel!NormalYearDaysPrecedingMonth = <no type information>
00000001`4004a5c0 securekernel!LeapYearDaysPrecedingMonth = <no type information>
00000001`4004a5e0 securekernel!RtlpUnwindOpSlotTable = <no type information>
00000001`4004a5f0 securekernel!RtlpInterceptorRoutines = <no type information>
00000001`4004a5f8 securekernel!SkeShadowSyncObjectType = <no type information>
00000001`4004a610 securekernel!_xmm = <no type information>
00000001`4004a620 securekernel!_xmm = <no type information>
00000001`4004a630 securekernel!_xmm = <no type information>
00000001`4004a640 securekernel!_xmm = <no type information>
00000001`4004a650 securekernel!_xmmc000009ac000009a00000000c0000002 = <no type information>
00000001`4004a6c0 securekernel!load_config_used = <no type information>
00000001`4004a760 securekernel!TraceLoggingMetadata = <no type information>
00000001`4004a825 securekernel!TraceLoggingMetadataEnd = <no type information>
00000001`4004fd04 securekernel!_IMPORT_DESCRIPTOR_skci = <no type information>
00000001`4004fd18 securekernel!_IMPORT_DESCRIPTOR_cng = <no type information>
00000001`4004fd2c securekernel!_NULL_IMPORT_DESCRIPTOR = <no type information>
00000001`40051000 securekernel!pctype = <no type information>
00000001`40051010 securekernel!_initiallocinfo = <no type information>
00000001`40051170 securekernel!_lconv_c = <no type information>
00000001`40051208 securekernel!_mb_cur_max = <no type information>
00000001`40051210 securekernel!SkiInterruptTablePhase1 = <no type information>
00000001`400513c0 securekernel!SkiInterruptTablePhase0 = <no type information>
00000001`40051440 securekernel!IumSyscallDispEntries = <no type information>
00000001`40051740 securekernel!SLEEPSTUDY_ETW_PROVIDER_Context = <no type information>
00000001`40051790 securekernel!IUM_ETW_PROVIDER_Context = <no type information>
00000001`400517d8 securekernel!SkiDueTime = <no type information>
00000001`400517e0 securekernel!SkLoadedModuleList = <no type information>
00000001`400517f0 securekernel!SkpDisableServerHibernation = <no type information>
00000001`400517f4 securekernel!SkpEncryptCrashData = <no type information>
00000001`400517f8 securekernel!SkpEncryptHiberData = <no type information>
00000001`40051800 securekernel!SkCapabilities = <no type information>
00000001`40051820 securekernel!SyscallBufferPoolProcessStats = <no type information>
00000001`40051af0 securekernel!SyscallBufferPoolConsts = <no type information>
00000001`40051b28 securekernel!MmUserProbeAddress = <no type information>
00000001`40051b30 securekernel!SkpEtwRegistrationListHead = <no type information>
00000001`40051b50 securekernel!PsInvertedFunctionTable = <no type information>
00000001`40053360 securekernel!IumSyscallArgDescriptor = <no type information>
00000001`40054edc securekernel!IumSyscallDescriptorLimit = <no type information>
00000001`40054ee0 securekernel!IumSyscallDescriptor = <no type information>
00000001`400555d0 securekernel!IumSecureSyscallDescriptorLimit = <no type information>
00000001`400555e0 securekernel!RtlpHeapFailureInfo = <no type information>
00000001`40055cc0 securekernel!_security_cookie_complement = <no type information>
00000001`40055cc8 securekernel!_security_cookie = <no type information>
00000001`40055d10 securekernel!SkiInitialPrcbStorage = <no type information>
00000001`40055f10 securekernel!SkeIdt = <no type information>
00000001`40056f10 securekernel!SkiBspThread = <no type information>
00000001`40056fc0 securekernel!SkiBspData = <no type information>
00000001`40057fc0 securekernel!SkpModuleListBuffer = <no type information>
00000001`400583c8 securekernel!Microsoft_Windows_IsolatedUserModeHandle = <no type information>
00000001`400583d0 securekernel!EmptyTrustletInstance = <no type information>
00000001`400583e0 securekernel!Microsoft_Windows_SleepStudyHandle = <no type information>
00000001`400583e8 securekernel!IumLkHandle = <no type information>
00000001`400583f0 securekernel!IumLkArrayHandle = <no type information>
00000001`400583f8 securekernel!IumIdkHandle = <no type information>
00000001`40058400 securekernel!IumMkPerBootHandle = <no type information>
00000001`40058410 securekernel!IumpSingleThreadedServiceRequestEntered = <no type information>
00000001`40058414 securekernel!g_ExpectedIumInitializationPhase = <no type information>
00000001`40058418 securekernel!PsIumSystemProcess = <no type information>
00000001`40058420 securekernel!g_IumSystemDirectoryTableBase = <no type information>
00000001`40058428 securekernel!IumVPCount = <no type information>
00000001`4005842c securekernel!NtGlobalFlag = <no type information>
00000001`40058440 securekernel!PerfGlobalGroupMask = <no type information>
00000001`40058468 securekernel!RtlpHeapKey = <no type information>
00000001`40058470 securekernel!RtlpHpHeapFeatures = <no type information>
00000001`40058474 securekernel!CmNtCSDVersion = <no type information>
00000001`40058478 securekernel!RtlpHeapErrorHandlerThreshold = <no type information>
00000001`40058498 securekernel!g_SecureBootPolicyBlobHeader = <no type information>
00000001`400584a8 securekernel!gbl_errno = <no type information>
00000001`400584ac securekernel!__PchSym_ = <no type information>
00000001`400584b0 securekernel!SRWLockSpinCount = <no type information>
00000001`400584b8 securekernel!Nls844UnicodeUpcaseTable = <no type information>
00000001`400584c0 securekernel!__PchSym_ = <no type information>
00000001`400584c4 securekernel!__PchSym_ = <no type information>
00000001`400584c8 securekernel!__PchSym_ = <no type information>
00000001`400584d0 securekernel!SkpHeapInitialReserveSize = <no type information>
00000001`400584e0 securekernel!SkpHeapLargeAllocationTree = <no type information>
00000001`400584f0 securekernel!SkpHeapLargeAllocationTreeLock = <no type information>
00000001`400584f8 securekernel!g_IumSystemHeap = <no type information>
00000001`40058500 securekernel!IumSecureSyscallDescriptor = <no type information>
00000001`40058520 securekernel!IumSyscallDispatchTable = <no type information>
00000001`40058c10 securekernel!SkImageSize = <no type information>
00000001`40058c18 securekernel!SkImageBase = <no type information>
00000001`40058c20 securekernel!pDestructExceptionObject = <no type information>
00000001`40058c28 securekernel!SkpEtwRegistrationListLock = <no type information>
00000001`40058c2c securekernel!__PchSym_ = <no type information>
00000001`40058c30 securekernel!SkpgInitialized = <no type information>
00000001`40058c40 securekernel!SkpgPatchGuardTimer = <no type information>
00000001`40058c88 securekernel!SkpgContext = <no type information>
00000001`40058c90 securekernel!SkpgBugCheckActive = <no type information>
00000001`40058c98 securekernel!SkpgConnectionLock = <no type information>
00000001`40058ca0 securekernel!__PchSym_ = <no type information>
00000001`40058ca4 securekernel!__PchSym_ = <no type information>
00000001`40058ca8 securekernel!SkobpGlobalHandleTable = <no type information>
00000001`40058cc0 securekernel!SkmiPoolPtes = <no type information>
00000001`40058ce8 securekernel!SkmiReservedImagePageLock = <no type information>
00000001`40058cf0 securekernel!SkmiReservedImagePage = <no type information>
00000001`40058cf8 securekernel!__PchSym_ = <no type information>
00000001`40058cfc securekernel!SkmiFreePageLock = <no type information>
00000001`40058d00 securekernel!SkmiFreeBundles = <no type information>
00000001`40058d10 securekernel!SkmiUnprotectedPageCount = <no type information>
00000001`40058d18 securekernel!SkmiDynamicMemoryLock = <no type information>
00000001`40058d20 securekernel!SkmiKernelPteLock = <no type information>
00000001`40058d24 securekernel!SkmiFailureLogLock = <no type information>
00000001`40058d28 securekernel!SkmiIntegrityExpansionLock = <no type information>
00000001`40058d2c securekernel!SkmiIntegrityListLock = <no type information>
00000001`40058d30 securekernel!SkmiFreeIntegrityPte = <no type information>
00000001`40058d34 securekernel!SkmiNextIntegrityPte = <no type information>
00000001`40058d38 securekernel!SkmiEmptyIntegrityPages = <no type information>
00000001`40058d40 securekernel!SkmiPartialIntegrityPages = <no type information>
00000001`40058d48 securekernel!SkmiTotalCommitment = <no type information>
00000001`40058d50 securekernel!SkmiCheckTableSize = <no type information>
00000001`40058d58 securekernel!SkmiEncryptionSequence = <no type information>
00000001`40058d60 securekernel!SkmiPageEncryptionContext = <no type information>
00000001`40058fc0 securekernel!SkmiSystemPtes = <no type information>
00000001`40059000 securekernel!SkmiNonPagedPtes = <no type information>
00000001`40059028 securekernel!SkmiReservedPagesRemaining = <no type information>
00000001`40059030 securekernel!SkmiReservedPagesStart = <no type information>
00000001`40059038 securekernel!SkmiLoaderPageDirectoryBase = <no type information>
00000001`40059040 securekernel!SkmiMemoryDescriptorListHead = <no type information>
00000001`40059048 securekernel!SkmiFreeMemoryDescriptor = <no type information>
00000001`40059050 securekernel!SkmiAllocatedMemoryDescriptor = <no type information>
00000001`40059060 securekernel!SkmiReservedDescriptors = <no type information>
00000001`40059078 securekernel!SkmiCodeIntegrityData = <no type information>
00000001`40059080 securekernel!SkmiCodeIntegrityDataSize = <no type information>
00000001`40059088 securekernel!SkmiUserSharedDataPfn = <no type information>
00000001`40059090 securekernel!SkmiFlags = <no type information>
00000001`40059098 securekernel!SkpNtosUserSharedData = <no type information>
00000001`400590a0 securekernel!ShvlpVtlReturn = <no type information>
00000001`400590a8 securekernel!__PchSym_ = <no type information>
00000001`400590b0 securekernel!ShvlpHandleRepHypercallIntercept = <no type information>
00000001`400590b8 securekernel!ShvlpHandleRegisterIntercept = <no type information>
00000001`400590c0 securekernel!ShvlpHandleMsrIntercept = <no type information>
00000001`400590c8 securekernel!ShvlpHypercallRoutine = <no type information>
00000001`400590d0 securekernel!ShvlpInputPa = <no type information>
00000001`400590d8 securekernel!ShvlpOutputPa = <no type information>
00000001`400590e0 securekernel!ShvlpEnteredMinimalDispatchLoop = <no type information>
00000001`400590e8 securekernel!ShvlpHypercallInputPage = <no type information>
00000001`400590f0 securekernel!ShvlpHypercallOutputPage = <no type information>
00000001`400590f8 securekernel!ShvlpBspSynicPage = <no type information>
00000001`40059100 securekernel!ShvlpSynicMessagePfn = <no type information>
00000001`40059108 securekernel!ShvlpVpAssistPfn = <no type information>
00000001`40059110 securekernel!ShvlpVtlCall = <no type information>
00000001`40059118 securekernel!ShvlpPageDirectoryBase = <no type information>
00000001`40059120 securekernel!ShvlpFlags = <no type information>
00000001`40059130 securekernel!ShvlpHypervisorFeatures = <no type information>
00000001`40059140 securekernel!ShvlpPartitionPrivilegeMask = <no type information>
00000001`40059150 securekernel!ShvlpEnlightenmentInfo = <no type information>
00000001`40059160 securekernel!ShvlpHypercallCodePage = <no type information>
00000001`40059168 securekernel!ShvlpReferenceTscPage = <no type information>
00000001`40059170 securekernel!ShvlpBspVpAssistPage = <no type information>
00000001`40059178 securekernel!ObjectLengthSP800108 = <no type information>
00000001`4005917c securekernel!ObjectLengthAesGcm = <no type information>
00000001`40059180 securekernel!SkpLiveDumpContext = <no type information>
00000001`400591b0 securekernel!SkpLiveDumpLock = <no type information>
00000001`400591c0 securekernel!SkpWorkItemList = <no type information>
00000001`400591d0 securekernel!SkpWorkItemListLock = <no type information>
00000001`400591d4 securekernel!__PchSym_ = <no type information>
00000001`400591d8 securekernel!IumSystemBuffers = <no type information>
00000001`400591e0 securekernel!IumSystemBufferBitmap = <no type information>
00000001`400591f0 securekernel!SkpEfiMappingAddress = <no type information>
00000001`400591f8 securekernel!SkEfiRuntimeInVtl1 = <no type information>
00000001`400591f9 securekernel!SkpEfiRuntimeInitialized = <no type information>
00000001`40059200 securekernel!SkpEfiRuntimeServices = <no type information>
00000001`40059288 securekernel!SkpEfiServiceLock = <no type information>
00000001`400592a0 securekernel!SkpEfiTransferMdl = <no type information>
00000001`4005a2a0 securekernel!SkPhase1InitStatus = <no type information>
00000001`4005a2a4 securekernel!SkpFlags = <no type information>
00000001`4005a2a8 securekernel!SkLastPerfCounter = <no type information>
00000001`4005a2b0 securekernel!SkPerfFrequency = <no type information>
00000001`4005a2b8 securekernel!SkpDeferredFreeList = <no type information>
00000001`4005a2c0 securekernel!SkpDeferredFreeWorker = <no type information>
00000001`4005a2e0 securekernel!SkiInitThread = <no type information>
00000001`4005a388 securekernel!SkiThreadTable = <no type information>
00000001`4005a390 securekernel!SkiThreadTableSize = <no type information>
00000001`4005a394 securekernel!SkiThreadTableExpansionLock = <no type information>
00000001`4005a398 securekernel!SkiFreeThreadIndex = <no type information>
00000001`4005a39c securekernel!SkiThreadPoolCount = <no type information>
00000001`4005a3a0 securekernel!SkiThreadPoolMask = <no type information>
00000001`4005a3a8 securekernel!SkiTimerCsActiveTime = <no type information>
00000001`4005a3b0 securekernel!SkiClockOwner = <no type information>
00000001`4005a3b4 securekernel!SkiTimerLock = <no type information>
00000001`4005a3b8 securekernel!SkiTimerMode = <no type information>
00000001`4005a3c0 securekernel!SkiTimerQueue = <no type information>
00000001`4005a3e0 securekernel!SkCsScenarioInstanceId = <no type information>
00000001`4005a3e1 securekernel!SkIdleResiliencyActive = <no type information>
00000001`4005a3e8 securekernel!SkiSynchronizedIpiLock = <no type information>
00000001`4005a3f0 securekernel!SkiProcessList = <no type information>
00000001`4005a400 securekernel!SkiProcessListLock = <no type information>
00000001`4005a420 securekernel!SkeInterruptCallback = <no type information>
00000001`4005ac20 securekernel!SkeProcessorBlock = <no type information>
00000001`4005c020 securekernel!SkeNumberProcessors = <no type information>
00000001`4005c024 securekernel!Microsoft_Windows_IsolatedUserModeEnableBits = <no type information>
00000001`4005c040 securekernel!g_SKTraceBuffer = <no type information>
00000001`40060040 securekernel!g_SKTraceIndex = <no type information>
00000001`40060044 securekernel!Microsoft_Windows_SleepStudyEnableBits = <no type information>
00000001`40060048 securekernel!__PchSym_ = <no type information>
00000001`4006004c securekernel!SkeLimitedModeActive = <no type information>
00000001`40060050 securekernel!SkeLoaderBlock = <no type information>
00000001`40060058 securekernel!SkiProcessorStartupLock = <no type information>
00000001`40064000 securekernel!SkmmDefaultVtlProtection = <no type information>
00000001`40064004 securekernel!SkiUseX2Apic = <no type information>
00000001`40064008 securekernel!SkmiFreeBundlePtes = <no type information>
00000001`40064010 securekernel!SkmiLowestPhysicalPage = <no type information>
00000001`40064018 securekernel!SkmiHighestPhysicalPage = <no type information>
00000001`40064020 securekernel!KiMxCsrMask = <no type information>
00000001`40064028 securekernel!SkmiReservedBundleMapping = <no type information>
00000001`40064030 securekernel!RtlpUnwindHistoryTable = <no type information>
00000001`40064110 securekernel!SkmiFailureLog = <no type information>
00000001`40064118 securekernel!SkCaseTableOffset = <no type information>
00000001`4006411c securekernel!SkNlsDataSize = <no type information>
00000001`40064120 securekernel!IumHiberCrashContext = <no type information>
00000001`40064218 securekernel!SkAnsiCodePageOffset = <no type information>
00000001`4006421c securekernel!SkApisetSchemaSize = <no type information>
00000001`40064220 securekernel!g_hExchangeVsmSource = <no type information>
00000001`40064228 securekernel!SkeUserPopEntrySListFault = <no type information>
00000001`40064230 securekernel!KiLastBranchTOSMSR = <no type information>
00000001`40064234 securekernel!KiLastBranchFromBaseMSR = <no type information>
00000001`40064238 securekernel!KiLastBranchToBaseMSR = <no type information>
00000001`4006423c securekernel!KiLastExceptionFromBaseMSR = <no type information>
00000001`40064240 securekernel!KiLastExceptionToBaseMSR = <no type information>
00000001`40064248 securekernel!SkpspLoaderInitRoutine = <no type information>
00000001`40064250 securekernel!SkpspUserThreadStart = <no type information>
00000001`40064258 securekernel!SkpspSystemDllInitBlock = <no type information>
00000001`40064260 securekernel!SkpspSystemDllRelocationDiff = <no type information>
00000001`40064268 securekernel!SkNlsDataPfnBase = <no type information>
00000001`40064270 securekernel!SkApisetSchemaPfnBase = <no type information>
00000001`40064278 securekernel!SkeUserPopEntrySListResume = <no type information>
00000001`40064280 securekernel!SkeUserExceptionDispatcher = <no type information>
00000001`40064288 securekernel!SkeFeatureBits = <no type information>
00000001`40064290 securekernel!SkBootEnvironmentInformation = <no type information>
00000001`400642b0 securekernel!SkeUserPopEntrySListEnd = <no type information>
00000001`400642b8 securekernel!IumUserInvertedFunctionTable = <no type information>
00000001`400642c0 securekernel!IumpNtosResumeContext = <no type information>
00000001`40064310 securekernel!SkeDefaultNpxState = <no type information>
00000001`40064510 securekernel!IumCrashCpuContext = <no type information>
00000001`40065000 securekernel!CaseTable = <no type information>
00000001`400676d0 securekernel!AnsiCodePage = <no type information>
00000001`40078000 securekernel!CheckHeapFillPattern = <no type information>
*/