#include "Helper.h"
//Open file for reading
HANDLE FileOpen(TCHAR *fileName);
//Read bytes safely from a file
BOOL SafeRead(HANDLE hFile, BYTE *buffer, UINT desiredBytes, PUINT readBytes);
//Search through a file for possible Process pool headers:
UINT SearchForProcHeader(HANDLE hFile, UINT noMb, ULONG64 *offsets);

BOOL ReturnFileHandleToStart(HANDLE hFile);


//Finds matching patterns in a given buffer
UINT Match(BYTE *searchBuffer, BYTE *pattern, PULONG64 offset, DWORD bufSize, UINT patLength);

//Find process image names:
BOOL SearchForImageNames(ULONG64 *offsets, UINT matches, TCHAR *fileName);

//Seach File For pattern:
UINT SearchFile(HANDLE hFile, BYTE *pattern, UINT patternLength, UINT numberOfMegaBytes, ULONG64 *offsetsFound, UINT maxFindings);

//Checks whether or not the POOL header is valid:
BOOL ValidHeader(BYTE *buffer, UINT offset);

//Traverse the active process list:
BOOL ListProcesses(ULONG64 eprocessAdr, HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);
BOOL ProcessData(ULONG64 eprocessAdr, HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);


BOOL OpenFiles(HANDLE *hFile1, HANDLE *hFile2, TCHAR *fileName1, TCHAR *fileName2);
BOOL CloseFiles(HANDLE *hFile1, HANDLE *hFile2);
BOOL ReturnFileHandleToStart(HANDLE hFile1);

//Output PEB data:
BOOL DumpPEB(ULONG64 pebAdr, ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2);

//Output memory:
BOOL OutputVirtual(ULONG64 virtAddress, ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2, UINT len);
BOOL OutputPhysical(ULONG64 physAddress, HANDLE hFile1, HANDLE hFile2, UINT len);

//Traverse VAD tree:
BOOL TraverseVadTree(ULONG64 vadRootAdr, HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);