/*************************************
Generic class for implementing the MMVAD
datastructure. By Hans Kristian Brendmo
*************************************/

#ifndef VAD_H
#define VAD_H

#define VADSIZE 112

#include <Windows.h>
#include "Helper.h"
#include "BALNODE.h"

class VAD
{
public:
	VAD();
	VAD(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir, ULONG64 vadAdr);
	~VAD();
	BOOL ReadData(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);
	BOOL ReadVadNode(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir, ULONG64 startAdr);
	ULONG64 getLeftVad(){return vadNode->getLeft();}
	ULONG64 getRightVad(){return vadNode->getRight();}
	VOID PrintInfo();
	VOID PrintData();
private:
	BALNODE *vadNode;
	ULONG64 vadAdr;
	BYTE rawData[VADSIZE]; //MMVAD data except VadNode member
	BOOL valid;
	BOOL dataRead;
};

#endif